<template>
  <ob-form
    :form-data="formData"
    :form-model="formModel"
    @submit="onSubmitHandler"
    :dropdown-menu="dropdownMenu"
  >
    <div class="row">
      <div class="col-xs-12">
        <ob-input
          :label="dictionaryRu.modal.name"
          v-model="formData.title[location]"
          property="name"
        />
      </div>
    </div>
    <div class="row">
      <div class="col-xs-4">
        <ob-select
          :label="dictionaryRu.modal.status"
          :items="statusItems"
          v-model="formData.is_active"
          :display-exp="'text'"
          :value-exp="'value'"
        />
      </div>
      <div class="col-xs-4">
        <ob-stepper
          :label="dictionaryRu.modal.number"
          v-model.number="formData.pos"
          property="number"
        />
      </div>
      <div class="col-xs-4">
        <ob-select
          :label="dictionaryRu.modal.type"
          :placeholder="dictionaryRu.modal.typePlaceholder"
          :items="types"
          v-model.number="formData.type"
          :display-exp="'text'"
          :value-exp="'value'"
        />
      </div>
    </div>
  </ob-form>
</template>

<script>
import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin';
import dropdownEvents      from '@/mixins/dictionaries/dropdown-events.js';
import ObInput             from 'common-components/src/obComponents/obInput';
import ObForm              from 'common-components/src/obComponents/obForm';
import models              from '@/models';
import ObStepper           from 'common-components/src/obComponents/obStepper';
import ObSelect            from 'common-components/src/obComponents/obSelect';
import { mapGetters }      from 'vuex';
import { dictionary } from '@/translations/ru/dictionaries__sb_dictionaries__requisite_groups';

export default {
  name: 'RequisitePopup',
  components: {
    ObStepper,
    ObForm,
    ObInput,
    ObSelect
  },
  mixins: [
    FormValidationMixin,
    dropdownEvents
  ],
  data() {
    return {
      dictionaryRu: dictionary
    }
  },
  computed: {
    ...mapGetters({
      location: 'getCurrentLocale'
    }),
    formModel() {
      return models.requisiteModel;
    },
    statusItems() {
      return [
        {
          value: true,
          text: this.dictionaryRu.status.active
        },
        {
          value: false,
          text: this.dictionaryRu.status.inactive
        }
      ];
    },
    types: () => [
      {
        value: 'participant',
        text: 'Участник'
      },
      {
        value: 'resource',
        text: 'Ресурс'
      }
    ]
  },
  methods: {
    onSubmitHandler(data) {
      this.$emit('save', data);
    }
  }
};
</script>
